Subject: Re: Notes on Using Git with Subprojects

From: A Large Angry SCM <[email-masked]>
Date: Wed, 27 Sep 2006 10:13:06 -0700

Johannes Schindelin wrote:
> Hi,
> 
> On Wed, 27 Sep 2006, Martin Waitz wrote:
> 
>> On Tue, Sep 26, 2006 at 03:33:49PM -0700, A Large Angry SCM wrote:
>>> So, for each subproject of a parent project, you want to record branch, 
>>> version (commit ID), and directory location. Not quite as easy to do in 
>>> a makefile but do-able.
>> I've been playing with this kind of subprojects a little bit.
>>
>> My current approach is like this:
>>
>>  * create a .gitmodules file which lists all the directories
>>    which contain a submodule.
>>  * the .git/refs/heads directory of the submodule gets stored in
>>    .gitmodule/<modulename> inside the parent project
> 
> Taking this a step further, you could make subproject/.git/refs/heads a 
> symbolic link to .git/refs/heads/subproject, with the benefit that fsck 
> Just Works.

Wouldn't an fsck in the parent complain about missing objects?